
# 10KN: Ten Thousand Korean Numeric System 🇰🇷

**10KN**은 숫자(0~9)와 한글(유니코드 '가'~'힣')만을 사용하여 0~9999까지의 값을 각 자릿수에서 표현하는 **초고압축 숫자 인코딩 시스템**입니다.

> 각 자리는 **항상 1글자**, 자릿수당 0~9999 표현 가능!  
> 기존 10진수 체계를 그대로 확장하면서, 압축성과 정렬성, 시각적 조화까지 모두 갖춘 한국식 수 체계입니다.

---

## ✅ 주요 특징

- **자릿값 범위**: 0~9999 (총 10,000개)
- **0~9**: 숫자 그대로 사용
- **10~9999**: 유니코드 한글 ('가'=1, '각'=2, ..., '힣'=9999)
- **문자열 길이 = 자릿수** (고정폭 인코딩)
- **정렬/복원/검색에 강함**
- **자릿수 제한 없음 → 우주 숫자 표현 가능**

---

## 💡 예제

| 10진수 | 10KN 표현 | 설명 |
|--------|-----------|------|
| 0      | `'0'`     | 기본값 |
| 9      | `'9'`     | 숫자 |
| 10     | `'가'`     | 첫 한글 |
| 12345  | `'1가5'`   | 1만 자리 = 1, 일의 자리 = 가, 마지막 자리 = 5 |
| 9999999999999999 | `'힣힣힣힣힣'` | 자릿수 5개로 표현하는 10경급 수 |

---

## 🧩 설치

```bash
pip install kn10  # (향후 PyPI 배포 시)
```

현재는 로컬 모듈로 사용:

```python
from kn10 import encode_kn10, decode_kn10

encoded = encode_kn10(123456789)
decoded = decode_kn10(encoded)

print(encoded)  # 예: '각졉읻'
print(decoded)  # 123456789
```

---

## 📜 라이선스

본 프로젝트는 [LICENSE](./LICENSE)에 따라 배포됩니다.  
> 누구든 자유롭게 사용할 수 있으나,  
> **수정은 불허**하며 **blueradiance 출처 명시가 필요합니다.**

---

## 👤 저자

- **blueradiance**  
- 깃허브: [github.com/blueradiance](https://github.com/blueradiance)
